/* *******************************************************************
   Webclient
   send data from Client -> Server

   ***************************************************************** */

// send data as POST to another webserver
// V3 no String class for sending data
void sendPost() {
  WiFiClient wificlient;
  HTTPClient client;
  const uint16_t MESSAGE_SIZE_MAX = 300;                   // maximum bytes for Message Buffer
  char message[MESSAGE_SIZE_MAX];                          // the temporary sending message - html body
  char val[32];                                            // buffer to convert floats and integers before appending

  strcpy(message, "board=");                               // append chars
  strcat(message, TXT_BOARDID);

  strcat(message, "&vcc=");                                // append integers
  itoa(ESP.getVcc(), val, 10);
  strcat(message, val);

  strcat(message, "&output1=");
  itoa(digitalRead(output1Pin), val, 10);
  strcat(message, val);

  strcat(message, "&output2=");
  itoa(digitalRead(output2Pin), val, 10);
  strcat(message, val);

  strcat(message, "&button1=");
  itoa(digitalRead(button1Pin), val, 10);
  strcat(message, val);

  float example = 1234.5678;                                                   // example how to append floats to the message
  strcat(message, "&float=");
  dtostrf(example, 6, 2, val);
  strcat(message, val);

  client.begin(wificlient, sendHttpTo);                                        // Specify request destination
  client.addHeader("Content-Type", "application/x-www-form-urlencoded");       // Specify content-type header
  int httpCode = client.POST(message);                                         // Send the request as POST (in the body of the message)
  Serial.print(F("\nhttpCode: "));
  Serial.println(httpCode);                                                    // Print HTTP return code
  //client.writeToStream(&Serial);                                             // Debug only: Output of received data
  if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY) {
    String payload = client.getString();
    //Serial.println(payload);
    // a simple parsing of the received payload
    payload.toCharArray(message, MESSAGE_SIZE_MAX);  // reuse message variabe/will be overwritten
    Serial.println(message);
    const char * delimiter = "=&";
    char * ptr = strtok(message, delimiter);
    while (ptr != NULL) {
      Serial.println(ptr);
      if (!strcmp(ptr, "board")) {
        ptr = strtok(NULL, delimiter);
        remoteBoardId = atoi(ptr);
        Serial.println(remoteBoardId);
      }
      else if (!strcmp(ptr, "remoteButton1")) {
        ptr = strtok(NULL, delimiter);
        remoteButton1 = atoi(ptr);
        Serial.println(remoteButton1);
      }
      else if (!strcmp(ptr, "remoteOutput1")) {
        ptr = strtok(NULL, delimiter);
        remoteOutput1 = atoi(ptr);
        Serial.println(remoteOutput1);
      }
      else if (!strcmp(ptr, "remoteOutput2")) {
        ptr = strtok(NULL, delimiter);
        remoteOutput2 = atoi(ptr);
        Serial.println(remoteOutput2);
      }
      else if (!strcmp(ptr, "remoteVcc")) {
        ptr = strtok(NULL, delimiter);
        remoteVcc = atoi(ptr);
        Serial.println(remoteVcc);
      }
      else if (!strcmp(ptr, "float")) {
        ptr = strtok(NULL, delimiter);
        remoteFloat = atof(ptr);
        Serial.println(remoteFloat);
      }
      ptr = strtok(NULL, delimiter);
    }
    remoteMessagesSucessfull++;
    remoteLastMessage = millis();
    Serial.print(F("remoteMessagesSucessfull=")); Serial.println(remoteMessagesSucessfull);
  }

  client.end();  //Close connection
}
